"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  astroExpressiveCode: () => astroExpressiveCode,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_remark_expressive_code = __toESM(require("remark-expressive-code"), 1);
__reExport(src_exports, require("remark-expressive-code"), module.exports);
function astroExpressiveCode(options = {}) {
  const integration = {
    name: "astro-expressive-code",
    hooks: {
      "astro:config:setup": async (args) => {
        const { config, updateConfig, injectScript } = args;
        const { customCreateRenderers } = options ?? {};
        const ownPosition = config.integrations.findIndex((integration2) => integration2.name === "astro-expressive-code");
        const mdxPosition = config.integrations.findIndex((integration2) => integration2.name === "@astrojs/mdx");
        if (ownPosition > -1 && mdxPosition > -1 && mdxPosition < ownPosition) {
          throw new Error(
            `Incorrect integration order: To allow code blocks on MDX pages to use
						astro-expressive-code, please move astroExpressiveCode() before mdx()
						in the "integrations" array of your Astro config file.`.replace(/\s+/g, " ")
          );
        }
        const renderers = await (customCreateRenderers ?? import_remark_expressive_code.createRenderers)(options);
        const jsModules = /* @__PURE__ */ new Set();
        renderers.forEach((renderer) => {
          renderer.jsModules.forEach((jsModule) => jsModules.add(jsModule));
          renderer.jsModules = [];
        });
        const remarkExpressiveCodeOptions = {
          ...options,
          customCreateRenderers: () => renderers
        };
        updateConfig({
          markdown: {
            syntaxHighlight: false,
            remarkPlugins: [[import_remark_expressive_code.default, remarkExpressiveCodeOptions]]
          }
        });
        jsModules.forEach((moduleCode) => injectScript("page", moduleCode));
      }
    }
  };
  return integration;
}
var src_default = astroExpressiveCode;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  astroExpressiveCode
});
//# sourceMappingURL=index.cjs.map